<template>
  <div
    ref="wrapper"
    :key="key"
  >
    <slot />
  </div>
</template>

<script lang="ts">
import { Vue, Component, Prop, Watch } from 'vue-property-decorator'

@Component
export default class MathRenderer extends Vue {
  @Prop({ type: Boolean, default: true }) enabled!: boolean

  key: Boolean = false

  forceRefresh() {
    this.key = !this.key
  }

  renderMath() {
    window.MathJax.typeset([this.$refs.wrapper])
  }

  resetMath() {
    window.MathJax.typesetClear([this.$refs.wrapper])
    // typesetClear only clears the cache but leaves the DOM untouched, so we
    // need to force it to rerender.
    this.forceRefresh()
  }

  mounted() {
    if (this.enabled)
      this.renderMath()
  }

  beforeDestroy() {
    this.resetMath()
  }

  @Watch('enabled')
  onEnabledChanged(changedToEnabled: boolean) {
    if (changedToEnabled)
      this.renderMath()
    else
      this.resetMath()
  }
}
</script>
